# Class VulkanViewport

java.lang.Object
com.io7m.jcoronado.api.VulkanViewport

All Implemented Interfaces:
  `VulkanViewportType`

public final class VulkanViewport extends Object implements VulkanViewportType
Structure specifying a viewport.

See Also:
  - "VkViewport"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanViewport.Builder`
  Builds instances of type `VulkanViewport`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanViewport.Builder`
  `builder()`
  Creates a builder for `VulkanViewport`.
  `static VulkanViewport`
  `copyOf(VulkanViewportType instance)`
  Creates an immutable copy of a `VulkanViewportType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanViewport` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `x`, `y`, `width`, `height`, `minDepth`, `maxDepth`.
  `float`
  `height()`
  `float`
  `maxDepth()`
  `float`
  `minDepth()`
  `static VulkanViewport`
  `of(float x, float y, float width, float height, float minDepth, float maxDepth)`
  Construct a new immutable `VulkanViewport` instance.
  `String`
  `toString()`
  Prints the immutable value `VulkanViewport` with attribute values.
  `float`
  `width()`
  `final VulkanViewport`
  `withHeight(float value)`
  Copy the current immutable object by setting a value for the `height` attribute.
  `final VulkanViewport`
  `withMaxDepth(float value)`
  Copy the current immutable object by setting a value for the `maxDepth` attribute.
  `final VulkanViewport`
  `withMinDepth(float value)`
  Copy the current immutable object by setting a value for the `minDepth` attribute.
  `final VulkanViewport`
  `withWidth(float value)`
  Copy the current immutable object by setting a value for the `width` attribute.
  `final VulkanViewport`
  `withX(float value)`
  Copy the current immutable object by setting a value for the `x` attribute.
  `final VulkanViewport`
  `withY(float value)`
  Copy the current immutable object by setting a value for the `y` attribute.
  `float`
  `x()`
  `float`
  `y()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public float x()
    Specified by:
      `x` in interface `VulkanViewportType`
    Returns:
      the viewport’s upper left corner

  - ### y

    public float y()
    Specified by:
      `y` in interface `VulkanViewportType`
    Returns:
      the viewport’s upper left corner

  - ### width

    public float width()
    Specified by:
      `width` in interface `VulkanViewportType`
    Returns:
      the viewport’s width

  - ### height

    public float height()
    Specified by:
      `height` in interface `VulkanViewportType`
    Returns:
      the viewport’s height

  - ### minDepth

    public float minDepth()
    Specified by:
      `minDepth` in interface `VulkanViewportType`
    Returns:
      the viewport’s depth range (minimum)

  - ### maxDepth

    public float maxDepth()
    Specified by:
      `maxDepth` in interface `VulkanViewportType`
    Returns:
      the viewport’s depth range (maximum)

  - ### withX

    public final VulkanViewport withX(float value)
    Copy the current immutable object by setting a value for the `x` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy of the `this` object

  - ### withY

    public final VulkanViewport withY(float value)
    Copy the current immutable object by setting a value for the `y` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy of the `this` object

  - ### withWidth

    public final VulkanViewport withWidth(float value)
    Copy the current immutable object by setting a value for the `width` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for width
    Returns:
      A modified copy of the `this` object

  - ### withHeight

    public final VulkanViewport withHeight(float value)
    Copy the current immutable object by setting a value for the `height` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for height
    Returns:
      A modified copy of the `this` object

  - ### withMinDepth

    public final VulkanViewport withMinDepth(float value)
    Copy the current immutable object by setting a value for the `minDepth` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for minDepth
    Returns:
      A modified copy of the `this` object

  - ### withMaxDepth

    public final VulkanViewport withMaxDepth(float value)
    Copy the current immutable object by setting a value for the `maxDepth` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maxDepth
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanViewport` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`, `width`, `height`, `minDepth`, `maxDepth`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanViewport` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanViewport of(float x, float y, float width, float height, float minDepth, float maxDepth)
    Construct a new immutable `VulkanViewport` instance.
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
      `width` - The value for the `width` attribute
      `height` - The value for the `height` attribute
      `minDepth` - The value for the `minDepth` attribute
      `maxDepth` - The value for the `maxDepth` attribute
    Returns:
      An immutable VulkanViewport instance

  - ### copyOf

    public static VulkanViewport copyOf(VulkanViewportType instance)
    Creates an immutable copy of a `VulkanViewportType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanViewport instance

  - ### builder

    public static VulkanViewport.Builder builder()
    Creates a builder for `VulkanViewport`.

         VulkanViewport.builder()
            .setX(float) // required x
            .setY(float) // required y
            .setWidth(float) // required width
            .setHeight(float) // required height
            .setMinDepth(float) // required minDepth
            .setMaxDepth(float) // required maxDepth
            .build();

    Returns:
      A new VulkanViewport builder